// $Id$

//=============================================================================
/**
 *  @file    beelib.cpp
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 1998-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <stdarg.h>
#include "jyugem/bee/beelib.h"
#include "jyugem/bee/dump_memory.h"


namespace jyugem { namespace bee
{

const std::string _empty_string(_TX(""));
BEE_Export const std::string& empty_string()
{
  return _empty_string;
}

/*---------------------------------------------------------------------------*/
/*                                                                           */
/* hex dump                                                                  */
/*                                                                           */
/*---------------------------------------------------------------------------*/
#ifndef BOUNDARY
#define BOUNDARY     0
#define NO_BOUNDARY  1
#endif

#define BYTE_FORMAT
#ifndef BYTE_FORMAT

void mem_dump(const BCHAR * startp, const BCHAR * endp, ULONG , int mode)
{
  dump_words dumper(mode);
  std::string buf;
  dumper(startp, (endp - startp) * sizeof(BCHAR) + 1, buf);
  b_printf(buf.c_str());
}

#else

void mem_dump(BCHAR * startp, BCHAR * endp, ULONG , int mode)
{
  dump_bytes dumper(mode);
  std::string buf;
  dumper(startp, (endp - startp) * sizeof(BCHAR) + 1, buf);
  b_printf(buf.c_str());
}

#endif

//
//
//
void hex_dump(BCHAR * startp, size_t size, std::string& hexstr, int mode)
{
  if (mode & DUMP_WORD)
  {
    dump_words dumper(mode);
    dumper(startp, size, hexstr);
  }
  else
  {
    dump_bytes dumper(mode);
    dumper(startp, size, hexstr);
  }
}

/*---------------------------------------------------------------------------*/
/* printf wrapper                                                            */
/*---------------------------------------------------------------------------*/
int b_printf(const BCHAR * fmt, ...)
{
  va_list arglist;
  va_start(arglist, fmt);

  ACE_DEBUG((fmt, LM_DEBUG, arglist));

  va_end(arglist);
  return 0;
}

/*---------------------------------------------------------------------------*/
int b_sprintf(void * ar, const BCHAR * fmt, ...)
{
  va_list arglist;
  va_start(arglist, fmt);

  _vstprintf((BCHAR *)ar, fmt, arglist);

  va_end(arglist);
  return 0;
}

/*---------------------------------------------------------------------------*/
void b_abort(const BCHAR * fmt, ...)
{
  va_list arglist;
  va_start(arglist, fmt);

  ACE_ERROR((fmt, LM_ERROR, arglist));

  BCHAR buffer[10000];
  _vstprintf(buffer, fmt, arglist);
  throw std::runtime_error(buffer);

  va_end(arglist);
  //exit(-1);
}


} } // *namespace* - jyugem::bee